package name.panitz.oose;

import static org.junit.Assert.*;

import org.junit.Before;
import org.junit.Test;

public class SimpleGeoGameTest {
  GeoGame g; 
  GeometricObject geo;
  SnowFlake snowFlake;
  Star star;
  SquaresObject squaresObject;
  IsoscelesTriangle triangle;

  @Before
  public void init(){
    geo =   new GeometricObject(new Vertex(0, 0), 10, 10, new Vertex(0.2, 0.7));
    snowFlake = new SnowFlake(4, new Vertex(160, 160), 150, new Vertex(1, 0.8));
    star = new Star(8,25, new Vertex(280, 390), 150, new Vertex(0.5, 0.6));
    squaresObject = new SquaresObject(2, new Vertex(480, 20), 200, new Vertex(1, 0.3));
    triangle = new IsoscelesTriangle(new Vertex(40,40), 80, 111, new Vertex(0.4,1.7));
    g = new SimpleGeoGame(geo,snowFlake,star,squaresObject,triangle);
  }
  
  @Test
  public void test1() {
    for (int i = 0; i < 200; i++) {
      g.move();
      g.collisionCheck();
    }
    assertEqualsV("Fehler nach 200 Zyklen",new Vertex(40,140),geo.corner);
    assertEqualsV("Fehler nach 200 Zyklen",new Vertex(332,240),snowFlake.corner);
    assertEqualsV("Fehler nach 200 Zyklen",new Vertex(409,431),star.corner);
    assertEqualsV("Fehler nach 200 Zyklen",new Vertex(520,80),squaresObject.corner);
    assertEqualsV("Fehler nach 200 Zyklen",new Vertex(120,380),triangle.corner);
    
  }
  void assertEqualsV(String m, Vertex v1 , Vertex v2){
     assertEquals(m+" in X Koordinate",(int)Math.round(v1.x),(int)Math.round(v2.x));
     assertEquals(m+" in > Koordinate",(int)Math.round(v1.y),(int)Math.round(v2.y));

  } 


  @Test
  public void test2() {
    for (int i = 0; i < 2000; i++) {
      g.move();
      g.collisionCheck();
    }
    assertEqualsV("Fehler nach 2000 Zyklen",new Vertex(37.5,130),geo.corner);
    assertEqualsV("Fehler nach 2000 Zyklen",new Vertex(385,35),snowFlake.corner);
    assertEqualsV("Fehler nach 2000 Zyklen",new Vertex(115,393),star.corner);
    assertEqualsV("Fehler nach 2000 Zyklen",new Vertex(480,359),squaresObject.corner);
    assertEqualsV("Fehler nach 2000 Zyklen",new Vertex(315,249),triangle.corner);    
  }

  @Test
  public void test3() {
    for (int i = 0; i < 10000; i++) {
      g.move();
      g.collisionCheck();
    }
    assertEqualsV("Fehler nach 10000 Zyklen",new Vertex(389.5,432.4),geo.corner);
    assertEqualsV("Fehler nach 10000 Zyklen",new Vertex(510.2,78.9),snowFlake.corner);
    assertEqualsV("Fehler nach 10000 Zyklen",new Vertex(113.4,11.2),star.corner);
    assertEqualsV("Fehler nach 10000 Zyklen",new Vertex(594.6,313.6),squaresObject.corner);
    assertEqualsV("Fehler nach 10000 Zyklen",new Vertex(233.3,290.7),triangle.corner);    
  }
}